automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: automake-1.7.4 generates suspicious Makefile.in


From: Alexandre Duret-Lutz
Subject: Re: automake-1.7.4 generates suspicious Makefile.in
Date: Sat, 17 May 2003 13:30:53 +0200
User-agent: Gnus/5.090016 (Oort Gnus v0.16) Emacs/21.3 (gnu/linux)

Hi Bruno,

| installdirs:
|       $(mkinstalldirs) $(DESTDIR)$(includedir)
| 
|       $(MAKE) $(AM_MAKEFLAGS) install-recursive
| 
| install: $(BUILT_SOURCES)
|       $(MAKE) $(AM_MAKEFLAGS) install-am

Eww... Thanks for noticing this!

I'm installing the following fix on HEAD and branch-1-7.
(I plan to release 1.7.5 tomorrow.)

2003-05-17  Alexandre Duret-Lutz  <address@hidden>

        * lib/am/install.am (install, install-exec, install-data, uninstall):
        Declare conditionally using a if/else/endif block instead of
        using ?SUBDIRS?-style conditions.  The latter fail when
        %maybe_BUILT_SOURCES% is replaced by several lines.
        This fixes a bug introduced on 2003-04-06.
        * tests/bsource.test: New file.
        * tests/Makefile.am (TESTS): Add bsource.test.
        Reported by Bruno Haible.


Index: lib/am/install.am
===================================================================
RCS file: /cvs/automake/automake/lib/am/install.am,v
retrieving revision 1.10.2.1
diff -u -r1.10.2.1 install.am
--- lib/am/install.am   6 Apr 2003 19:27:53 -0000       1.10.2.1
+++ lib/am/install.am   17 May 2003 11:09:29 -0000
@@ -34,18 +34,20 @@
 ## ----------------- ##
 
 .PHONY: install install-exec install-data uninstall
-
-?SUBDIRS?.PHONY: install-recursive install-exec-recursive 
install-data-recursive uninstall-recursive
-?SUBDIRS?install:%maybe_BUILT_SOURCES% install-recursive
-?SUBDIRS?install-exec: install-exec-recursive
-?SUBDIRS?install-data: install-data-recursive
-?SUBDIRS?uninstall: uninstall-recursive
-
 .PHONY: install-exec-am install-data-am uninstall-am
-?!SUBDIRS?install:%maybe_BUILT_SOURCES% install-am
-?!SUBDIRS?install-exec: install-exec-am
-?!SUBDIRS?install-data: install-data-am
-?!SUBDIRS?uninstall: uninstall-am
+
+if %?SUBDIRS%
+.PHONY: install-recursive install-exec-recursive install-data-recursive 
uninstall-recursive
+install:%maybe_BUILT_SOURCES% install-recursive
+install-exec: install-exec-recursive
+install-data: install-data-recursive
+uninstall: uninstall-recursive
+else !%?SUBDIRS%
+install:%maybe_BUILT_SOURCES% install-am
+install-exec: install-exec-am
+install-data: install-data-am
+uninstall: uninstall-am
+endif !%?SUBDIRS%
 
 .PHONY: install-am
 install-am: all-am
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.443.2.27
diff -u -r1.443.2.27 Makefile.am
--- tests/Makefile.am   19 Apr 2003 11:27:29 -0000      1.443.2.27
+++ tests/Makefile.am   17 May 2003 11:09:29 -0000
@@ -46,6 +46,7 @@
 badline.test \
 badprog.test \
 block.test \
+bsource.test \
 canon.test \
 canon2.test \
 canon3.test \
Index: tests/bsource.test
===================================================================
RCS file: tests/bsource.test
diff -N tests/bsource.test
--- /dev/null   1 Jan 1970 00:00:00 -0000
+++ tests/bsource.test  17 May 2003 11:09:29 -0000
@@ -0,0 +1,37 @@
+#! /bin/sh
+# Copyright (C) 2003  Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING.  If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Regression test for install-recursive appearing in a non recursive Makefile.
+# Report from Bruno Haible.
+
+. ./defs || exit 1
+
+set -e
+
+cat > Makefile.am << 'END'
+noinst_SCRIPTS = hostname
+include_HEADERS = gettext-po.h
+BUILT_SOURCES = po-hash-gen.c
+END
+
+$ACLOCAL
+$AUTOMAKE
+grep 'install-recursive' Makefile.in && exit 1
+:
-- 
Alexandre Duret-Lutz





reply via email to

[Prev in Thread] Current Thread [Next in Thread]